<HTML>
<BODY BGCOLOR="white">
<PRE>
<FONT color="green">001</FONT>    /*<a name="line.1"></a>
<FONT color="green">002</FONT>     * =============================================================================<a name="line.2"></a>
<FONT color="green">003</FONT>     * Simplified BSD License, see http://www.opensource.org/licenses/<a name="line.3"></a>
<FONT color="green">004</FONT>     * -----------------------------------------------------------------------------<a name="line.4"></a>
<FONT color="green">005</FONT>     * Copyright (c) 2008-2009, Marco Terzer, Zurich, Switzerland<a name="line.5"></a>
<FONT color="green">006</FONT>     * All rights reserved.<a name="line.6"></a>
<FONT color="green">007</FONT>     * <a name="line.7"></a>
<FONT color="green">008</FONT>     * Redistribution and use in source and binary forms, with or without <a name="line.8"></a>
<FONT color="green">009</FONT>     * modification, are permitted provided that the following conditions are met:<a name="line.9"></a>
<FONT color="green">010</FONT>     * <a name="line.10"></a>
<FONT color="green">011</FONT>     *     * Redistributions of source code must retain the above copyright notice, <a name="line.11"></a>
<FONT color="green">012</FONT>     *       this list of conditions and the following disclaimer.<a name="line.12"></a>
<FONT color="green">013</FONT>     *     * Redistributions in binary form must reproduce the above copyright <a name="line.13"></a>
<FONT color="green">014</FONT>     *       notice, this list of conditions and the following disclaimer in the <a name="line.14"></a>
<FONT color="green">015</FONT>     *       documentation and/or other materials provided with the distribution.<a name="line.15"></a>
<FONT color="green">016</FONT>     *     * Neither the name of the Swiss Federal Institute of Technology Zurich <a name="line.16"></a>
<FONT color="green">017</FONT>     *       nor the names of its contributors may be used to endorse or promote <a name="line.17"></a>
<FONT color="green">018</FONT>     *       products derived from this software without specific prior written <a name="line.18"></a>
<FONT color="green">019</FONT>     *       permission.<a name="line.19"></a>
<FONT color="green">020</FONT>     * <a name="line.20"></a>
<FONT color="green">021</FONT>     * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" <a name="line.21"></a>
<FONT color="green">022</FONT>     * AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE <a name="line.22"></a>
<FONT color="green">023</FONT>     * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE <a name="line.23"></a>
<FONT color="green">024</FONT>     * ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE <a name="line.24"></a>
<FONT color="green">025</FONT>     * LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR <a name="line.25"></a>
<FONT color="green">026</FONT>     * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF <a name="line.26"></a>
<FONT color="green">027</FONT>     * SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS <a name="line.27"></a>
<FONT color="green">028</FONT>     * INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN <a name="line.28"></a>
<FONT color="green">029</FONT>     * CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) <a name="line.29"></a>
<FONT color="green">030</FONT>     * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE <a name="line.30"></a>
<FONT color="green">031</FONT>     * POSSIBILITY OF SUCH DAMAGE.<a name="line.31"></a>
<FONT color="green">032</FONT>     * =============================================================================<a name="line.32"></a>
<FONT color="green">033</FONT>     */<a name="line.33"></a>
<FONT color="green">034</FONT>    package ch.javasoft.io;<a name="line.34"></a>
<FONT color="green">035</FONT>    <a name="line.35"></a>
<FONT color="green">036</FONT>    import java.io.DataInput;<a name="line.36"></a>
<FONT color="green">037</FONT>    import java.io.DataInputStream;<a name="line.37"></a>
<FONT color="green">038</FONT>    import java.io.EOFException;<a name="line.38"></a>
<FONT color="green">039</FONT>    import java.io.IOException;<a name="line.39"></a>
<FONT color="green">040</FONT>    import java.io.InputStream;<a name="line.40"></a>
<FONT color="green">041</FONT>    <a name="line.41"></a>
<FONT color="green">042</FONT>    /**<a name="line.42"></a>
<FONT color="green">043</FONT>     * The &lt;tt&gt;AbstractDataInput&lt;/tt&gt; class implements most methods of<a name="line.43"></a>
<FONT color="green">044</FONT>     * {@link DataInput}, leaving only the following methods for subclasses: <a name="line.44"></a>
<FONT color="green">045</FONT>     * &lt;ul&gt;<a name="line.45"></a>
<FONT color="green">046</FONT>     * &lt;li&gt;{@link #read()}&lt;/li&gt;<a name="line.46"></a>
<FONT color="green">047</FONT>     * &lt;li&gt;{@link #peek()}&lt;/li&gt;<a name="line.47"></a>
<FONT color="green">048</FONT>     * &lt;li&gt;{@link #read(byte[], int, int)}&lt;/li&gt;<a name="line.48"></a>
<FONT color="green">049</FONT>     * &lt;li&gt;{@link #skipBytes(int)}&lt;/li&gt;<a name="line.49"></a>
<FONT color="green">050</FONT>     * &lt;/ul&gt;<a name="line.50"></a>
<FONT color="green">051</FONT>     * &lt;p&gt;<a name="line.51"></a>
<FONT color="green">052</FONT>     * This class is thread safe.<a name="line.52"></a>
<FONT color="green">053</FONT>     */<a name="line.53"></a>
<FONT color="green">054</FONT>    abstract public class AbstractDataInput implements DataInput {<a name="line.54"></a>
<FONT color="green">055</FONT>    <a name="line.55"></a>
<FONT color="green">056</FONT>        /**<a name="line.56"></a>
<FONT color="green">057</FONT>         * Reads a byte of data from this file. The byte is returned as an <a name="line.57"></a>
<FONT color="green">058</FONT>         * integer in the range 0 to 255 (&lt;code&gt;0x00-0x0ff&lt;/code&gt;). This <a name="line.58"></a>
<FONT color="green">059</FONT>         * method should block if no input is yet available. <a name="line.59"></a>
<FONT color="green">060</FONT>         * &lt;p&gt;<a name="line.60"></a>
<FONT color="green">061</FONT>         * Although &lt;code&gt;AbstractDataInput&lt;/code&gt; is not a subclass of <a name="line.61"></a>
<FONT color="green">062</FONT>         * &lt;code&gt;InputStream&lt;/code&gt;, this method behaves in exactly the same <a name="line.62"></a>
<FONT color="green">063</FONT>         * way as the {@link InputStream#read()} method of <a name="line.63"></a>
<FONT color="green">064</FONT>         * &lt;code&gt;InputStream&lt;/code&gt;.<a name="line.64"></a>
<FONT color="green">065</FONT>         *<a name="line.65"></a>
<FONT color="green">066</FONT>         * @return     the next byte of data, or &lt;code&gt;-1&lt;/code&gt; if the end of the<a name="line.66"></a>
<FONT color="green">067</FONT>         *             input has been reached.<a name="line.67"></a>
<FONT color="green">068</FONT>         * @exception  IOException  if an I/O error occurs. Not thrown if  <a name="line.68"></a>
<FONT color="green">069</FONT>         *                          end-of-file has been reached.<a name="line.69"></a>
<FONT color="green">070</FONT>         */<a name="line.70"></a>
<FONT color="green">071</FONT>            abstract protected int read() throws IOException;<a name="line.71"></a>
<FONT color="green">072</FONT>    <a name="line.72"></a>
<FONT color="green">073</FONT>            /**<a name="line.73"></a>
<FONT color="green">074</FONT>             * Like {@link #read()}, but the value is read again, that is, the position<a name="line.74"></a>
<FONT color="green">075</FONT>             * is not moved forward. This method is used by {@link #readLine()}, if<a name="line.75"></a>
<FONT color="green">076</FONT>             * subclasses cannot support this method, an i/o exception should be thrown,<a name="line.76"></a>
<FONT color="green">077</FONT>             * causing that {@link #readLine()} will also throw an i/o exception.<a name="line.77"></a>
<FONT color="green">078</FONT>             * <a name="line.78"></a>
<FONT color="green">079</FONT>             * @throws IOException  if peek operations are not supported<a name="line.79"></a>
<FONT color="green">080</FONT>             */<a name="line.80"></a>
<FONT color="green">081</FONT>            abstract protected int peek() throws IOException;<a name="line.81"></a>
<FONT color="green">082</FONT>            <a name="line.82"></a>
<FONT color="green">083</FONT>        /**<a name="line.83"></a>
<FONT color="green">084</FONT>         * Reads a sub array as a sequence of bytes. <a name="line.84"></a>
<FONT color="green">085</FONT>         * @param b the buffer into which the data is read.<a name="line.85"></a>
<FONT color="green">086</FONT>         * @param off the start offset of the data.<a name="line.86"></a>
<FONT color="green">087</FONT>         * @param len the number of bytes to read.<a name="line.87"></a>
<FONT color="green">088</FONT>         * @exception IOException If an I/O error has occurred.<a name="line.88"></a>
<FONT color="green">089</FONT>         */<a name="line.89"></a>
<FONT color="green">090</FONT>        abstract protected int read(byte b[], int off, int len) throws IOException;<a name="line.90"></a>
<FONT color="green">091</FONT>    <a name="line.91"></a>
<FONT color="green">092</FONT>            abstract public int skipBytes(int n) throws IOException;<a name="line.92"></a>
<FONT color="green">093</FONT>    <a name="line.93"></a>
<FONT color="green">094</FONT>            public boolean readBoolean() throws IOException {<a name="line.94"></a>
<FONT color="green">095</FONT>                    int ch = read();<a name="line.95"></a>
<FONT color="green">096</FONT>                    if (ch &lt; 0)<a name="line.96"></a>
<FONT color="green">097</FONT>                        throw new EOFException();<a name="line.97"></a>
<FONT color="green">098</FONT>                    return (ch != 0);<a name="line.98"></a>
<FONT color="green">099</FONT>            }<a name="line.99"></a>
<FONT color="green">100</FONT>    <a name="line.100"></a>
<FONT color="green">101</FONT>            public byte readByte() throws IOException {<a name="line.101"></a>
<FONT color="green">102</FONT>                    int ch = this.read();<a name="line.102"></a>
<FONT color="green">103</FONT>                    if (ch &lt; 0)<a name="line.103"></a>
<FONT color="green">104</FONT>                        throw new EOFException();<a name="line.104"></a>
<FONT color="green">105</FONT>                    return (byte)(ch);<a name="line.105"></a>
<FONT color="green">106</FONT>            }<a name="line.106"></a>
<FONT color="green">107</FONT>    <a name="line.107"></a>
<FONT color="green">108</FONT>            public char readChar() throws IOException {<a name="line.108"></a>
<FONT color="green">109</FONT>                    int ch1 = this.read();<a name="line.109"></a>
<FONT color="green">110</FONT>                    int ch2 = this.read();<a name="line.110"></a>
<FONT color="green">111</FONT>                    if ((ch1 | ch2) &lt; 0)<a name="line.111"></a>
<FONT color="green">112</FONT>                        throw new EOFException();<a name="line.112"></a>
<FONT color="green">113</FONT>                    return (char)((ch1 &lt;&lt; 8) + (ch2 &lt;&lt; 0));<a name="line.113"></a>
<FONT color="green">114</FONT>            }<a name="line.114"></a>
<FONT color="green">115</FONT>    <a name="line.115"></a>
<FONT color="green">116</FONT>            public double readDouble() throws IOException {<a name="line.116"></a>
<FONT color="green">117</FONT>                    return Double.longBitsToDouble(readLong());<a name="line.117"></a>
<FONT color="green">118</FONT>            }<a name="line.118"></a>
<FONT color="green">119</FONT>    <a name="line.119"></a>
<FONT color="green">120</FONT>            public float readFloat() throws IOException {<a name="line.120"></a>
<FONT color="green">121</FONT>                    return Float.intBitsToFloat(readInt());<a name="line.121"></a>
<FONT color="green">122</FONT>            }<a name="line.122"></a>
<FONT color="green">123</FONT>    <a name="line.123"></a>
<FONT color="green">124</FONT>            public void readFully(byte[] b) throws IOException {<a name="line.124"></a>
<FONT color="green">125</FONT>                    readFully(b, 0, b.length);<a name="line.125"></a>
<FONT color="green">126</FONT>            }<a name="line.126"></a>
<FONT color="green">127</FONT>    <a name="line.127"></a>
<FONT color="green">128</FONT>            public void readFully(byte[] b, int off, int len) throws IOException {<a name="line.128"></a>
<FONT color="green">129</FONT>            int n = 0;<a name="line.129"></a>
<FONT color="green">130</FONT>            do {<a name="line.130"></a>
<FONT color="green">131</FONT>                int count = read(b, off + n, len - n);<a name="line.131"></a>
<FONT color="green">132</FONT>                if (count &lt; 0)<a name="line.132"></a>
<FONT color="green">133</FONT>                    throw new EOFException();<a name="line.133"></a>
<FONT color="green">134</FONT>                n += count;<a name="line.134"></a>
<FONT color="green">135</FONT>            } while (n &lt; len);<a name="line.135"></a>
<FONT color="green">136</FONT>            }<a name="line.136"></a>
<FONT color="green">137</FONT>    <a name="line.137"></a>
<FONT color="green">138</FONT>            public int readInt() throws IOException {<a name="line.138"></a>
<FONT color="green">139</FONT>                    int ch1 = this.read();<a name="line.139"></a>
<FONT color="green">140</FONT>                    int ch2 = this.read();<a name="line.140"></a>
<FONT color="green">141</FONT>                    int ch3 = this.read();<a name="line.141"></a>
<FONT color="green">142</FONT>                    int ch4 = this.read();<a name="line.142"></a>
<FONT color="green">143</FONT>                    if ((ch1 | ch2 | ch3 | ch4) &lt; 0)<a name="line.143"></a>
<FONT color="green">144</FONT>                        throw new EOFException();<a name="line.144"></a>
<FONT color="green">145</FONT>                    return ((ch1 &lt;&lt; 24) + (ch2 &lt;&lt; 16) + (ch3 &lt;&lt; 8) + (ch4 &lt;&lt; 0));<a name="line.145"></a>
<FONT color="green">146</FONT>            }<a name="line.146"></a>
<FONT color="green">147</FONT>    <a name="line.147"></a>
<FONT color="green">148</FONT>            final ThreadLocal&lt;char[]&gt; lineBuffer = new ThreadLocal&lt;char[]&gt;();<a name="line.148"></a>
<FONT color="green">149</FONT>            /**<a name="line.149"></a>
<FONT color="green">150</FONT>             * Note that this method throws an i/o exception if the {@link #peek()} <a name="line.150"></a>
<FONT color="green">151</FONT>             * method is not supported.<a name="line.151"></a>
<FONT color="green">152</FONT>             * <a name="line.152"></a>
<FONT color="green">153</FONT>             * @see #peek()<a name="line.153"></a>
<FONT color="green">154</FONT>             * @see DataInput#readLine()<a name="line.154"></a>
<FONT color="green">155</FONT>             */<a name="line.155"></a>
<FONT color="green">156</FONT>            public String readLine() throws IOException {<a name="line.156"></a>
<FONT color="green">157</FONT>                    //check support of readLine by calling peek;<a name="line.157"></a>
<FONT color="green">158</FONT>                    peek();<a name="line.158"></a>
<FONT color="green">159</FONT>                    <a name="line.159"></a>
<FONT color="green">160</FONT>                    char buf[] = lineBuffer.get();<a name="line.160"></a>
<FONT color="green">161</FONT>    <a name="line.161"></a>
<FONT color="green">162</FONT>                    if (buf == null) {<a name="line.162"></a>
<FONT color="green">163</FONT>                        lineBuffer.set(buf = new char[128]);<a name="line.163"></a>
<FONT color="green">164</FONT>                    }<a name="line.164"></a>
<FONT color="green">165</FONT>    <a name="line.165"></a>
<FONT color="green">166</FONT>                    int room = buf.length;<a name="line.166"></a>
<FONT color="green">167</FONT>                    int offset = 0;<a name="line.167"></a>
<FONT color="green">168</FONT>                    int c;<a name="line.168"></a>
<FONT color="green">169</FONT>    <a name="line.169"></a>
<FONT color="green">170</FONT>            loop:   while (true) {<a name="line.170"></a>
<FONT color="green">171</FONT>                        switch (c = read()) {<a name="line.171"></a>
<FONT color="green">172</FONT>                          case -1:<a name="line.172"></a>
<FONT color="green">173</FONT>                          case '\n':<a name="line.173"></a>
<FONT color="green">174</FONT>                            break loop;<a name="line.174"></a>
<FONT color="green">175</FONT>    <a name="line.175"></a>
<FONT color="green">176</FONT>                          case '\r':<a name="line.176"></a>
<FONT color="green">177</FONT>                            int c2 = peek();<a name="line.177"></a>
<FONT color="green">178</FONT>                            if ((c2 == '\n')) {<a name="line.178"></a>
<FONT color="green">179</FONT>                                    c2 = read();//consume it<a name="line.179"></a>
<FONT color="green">180</FONT>                            }<a name="line.180"></a>
<FONT color="green">181</FONT>                            break loop;<a name="line.181"></a>
<FONT color="green">182</FONT>    <a name="line.182"></a>
<FONT color="green">183</FONT>                          default:<a name="line.183"></a>
<FONT color="green">184</FONT>                            if (--room &lt; 0) {<a name="line.184"></a>
<FONT color="green">185</FONT>                                buf = new char[offset + 128];<a name="line.185"></a>
<FONT color="green">186</FONT>                                room = buf.length - offset - 1;<a name="line.186"></a>
<FONT color="green">187</FONT>                                System.arraycopy(lineBuffer.get(), 0, buf, 0, offset);<a name="line.187"></a>
<FONT color="green">188</FONT>                                lineBuffer.set(buf);<a name="line.188"></a>
<FONT color="green">189</FONT>                            }<a name="line.189"></a>
<FONT color="green">190</FONT>                            buf[offset++] = (char) c;<a name="line.190"></a>
<FONT color="green">191</FONT>                            break;<a name="line.191"></a>
<FONT color="green">192</FONT>                        }<a name="line.192"></a>
<FONT color="green">193</FONT>                    }<a name="line.193"></a>
<FONT color="green">194</FONT>                    if ((c == -1) &amp;&amp; (offset == 0)) {<a name="line.194"></a>
<FONT color="green">195</FONT>                        return null;<a name="line.195"></a>
<FONT color="green">196</FONT>                    }<a name="line.196"></a>
<FONT color="green">197</FONT>                    return String.copyValueOf(buf, 0, offset);<a name="line.197"></a>
<FONT color="green">198</FONT>            }<a name="line.198"></a>
<FONT color="green">199</FONT>    <a name="line.199"></a>
<FONT color="green">200</FONT>            public long readLong() throws IOException {<a name="line.200"></a>
<FONT color="green">201</FONT>                    return ((long)(readInt()) &lt;&lt; 32) + (readInt() &amp; 0xFFFFFFFFL);<a name="line.201"></a>
<FONT color="green">202</FONT>            }<a name="line.202"></a>
<FONT color="green">203</FONT>    <a name="line.203"></a>
<FONT color="green">204</FONT>            public short readShort() throws IOException {<a name="line.204"></a>
<FONT color="green">205</FONT>                    int ch1 = this.read();<a name="line.205"></a>
<FONT color="green">206</FONT>                    int ch2 = this.read();<a name="line.206"></a>
<FONT color="green">207</FONT>                    if ((ch1 | ch2) &lt; 0)<a name="line.207"></a>
<FONT color="green">208</FONT>                        throw new EOFException();<a name="line.208"></a>
<FONT color="green">209</FONT>                    return (short)((ch1 &lt;&lt; 8) + (ch2 &lt;&lt; 0));<a name="line.209"></a>
<FONT color="green">210</FONT>            }<a name="line.210"></a>
<FONT color="green">211</FONT>    <a name="line.211"></a>
<FONT color="green">212</FONT>            public String readUTF() throws IOException {<a name="line.212"></a>
<FONT color="green">213</FONT>                    return DataInputStream.readUTF(this);<a name="line.213"></a>
<FONT color="green">214</FONT>            }<a name="line.214"></a>
<FONT color="green">215</FONT>    <a name="line.215"></a>
<FONT color="green">216</FONT>            public int readUnsignedByte() throws IOException {<a name="line.216"></a>
<FONT color="green">217</FONT>                    int ch = this.read();<a name="line.217"></a>
<FONT color="green">218</FONT>                    if (ch &lt; 0)<a name="line.218"></a>
<FONT color="green">219</FONT>                        throw new EOFException();<a name="line.219"></a>
<FONT color="green">220</FONT>                    return ch;<a name="line.220"></a>
<FONT color="green">221</FONT>            }<a name="line.221"></a>
<FONT color="green">222</FONT>    <a name="line.222"></a>
<FONT color="green">223</FONT>            public int readUnsignedShort() throws IOException {<a name="line.223"></a>
<FONT color="green">224</FONT>                    int ch1 = this.read();<a name="line.224"></a>
<FONT color="green">225</FONT>                    int ch2 = this.read();<a name="line.225"></a>
<FONT color="green">226</FONT>                    if ((ch1 | ch2) &lt; 0)<a name="line.226"></a>
<FONT color="green">227</FONT>                        throw new EOFException();<a name="line.227"></a>
<FONT color="green">228</FONT>                    return (ch1 &lt;&lt; 8) + (ch2 &lt;&lt; 0);<a name="line.228"></a>
<FONT color="green">229</FONT>            }<a name="line.229"></a>
<FONT color="green">230</FONT>    <a name="line.230"></a>
<FONT color="green">231</FONT>    }<a name="line.231"></a>




























































</PRE>
</BODY>
</HTML>
